//=============================================================================
// ListPCI - demo program for IOMemory class library
//  Copyright (C) 2000, UAB BBDSoft ( http://www.bbdsoft.com/ )
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
//  The author of this program may be contacted at developers@bbdsoft.com
//=============================================================================

#ifndef _PCICURS_
   #include "pcicurs.hpp"
#endif

#ifndef _IOSTREAM_
   #include <iostream>
#endif

using namespace std;

//----------------------------------------------------------------------------
void main ()
{
try
{
   PCICursor aCursor;
   for  (aCursor.first(); aCursor.isValid(); aCursor.next())
   {
      PCIDeviceInfo & aCard = aCursor.deviceAtCursor();
      cout << endl << "PCI Device.................." << endl
           << "       Vendor id: " << aCard.vendorId() << endl
           << "       Device id: " << aCard.deviceId() << endl
           << "          Status: " << aCard.status() << endl
           << "     Revision id: " << (int) (aCard.revisionId()) << endl
           << "         Prog If: " << (int) (aCard.progIf ()) << endl
           << "       Sub Class: " << (int) (aCard.subClass ()) << endl
           << "      Base Class: " << (int) (aCard.baseClass ()) << endl
           << " Cache Line Size: " << (int) (aCard.cacheLineSize ()) << endl
           << "   Latency Timer: " << (int) (aCard.latencyTimer ()) << endl
           << "     Header Type: " << (int) (aCard.headerType ()) << endl
           << "            BIST: " << (int) (aCard.BIST ()) << endl;

      for (int i=0; i<5; i++)
      {
         cout << "  Base address " << i << ": " << (void*) aCard.baseAddress(i) << endl;
      } // endfor
      cout << "             CIS: " << aCard.CIS () << endl
           << "   Sub Vendor id: " << aCard.subVendorId () << endl
           << "   Sub System id: " << aCard.subSystemId () << endl
           << "ROM Base Address: " << aCard.ROMBaseAddress () << endl
           << "    Capabilities: " << (int) (aCard.capabilityList ()) << endl
           << "  Interrupt Line: " << (int) (aCard.interruptLine ()) << endl
           << "   Interrupt Pin: " << (int) (aCard.interruptPin ()) << endl
           << "   Maximum Grant: " << (int) (aCard.minimumGrant ()) << endl
           << " Maximum Latency: " << (int) (aCard.maximumLatency ()) << endl;
   } // endfor
} 
catch (exception & exc)
{
   cout << exc.what () << endl;
   cout.flush();
} // endcatch
} // end main ()